CIN_REGEXP = r"[A-Z]{0,3}\d{1,7}[A-Z]?"

CIN_PREFIX_MAP = {
    "RABAT": ["A", "AA", "AG", "AC", "AJ"],
    "SALE": ["AB", "AE", "AY", "AS"],
    "TEMARA": ["AD"],
    "KENITRA": ["G"],
    "SIDI SLIMANE, SIDI YAHYA GHARB": ["GA"],
    "SOUK EL ARBAA DU GHARB": ["GB"],
    "SIDI KACEM": ["GK"],
    "OUEZZANE": ["GM"],
    "MECHRAA BELQSIRI": ["GN"],
    "JORF EL MELHA": ["GJ"],
    "CASABLANCA": [
        "B",
        "BA",
        "BB",
        "BE",
        "BH",
        "BJ",
        "BK",
        "BL",
        "BM",
        "BF",
        "BV",
        "BW",
    ],
    "MOHAMMEDIA": ["T"],
    "BENSLIMANE": ["TA", "TK"],
    "SETTAT": ["W"],
    "BERRECHID": ["WA"],
    "BEN AHMED": ["WB"],
    "FES": ["C", "CC", "CD"],
    "SEFROU": ["CB"],
    "BOULEMANE": ["CN"],
    "MEKNES": ["D", "DN"],
    "AZROU": ["DA"],
    "IFRANE": ["DB"],
    "MOULAY DRISS ZERHOUN": ["DC"],
    "AIN TAOUJDATE": ["DJ"],
    "OUISLANE": ["DO"],
    "MARRAKECH": ["E", "EE"],
    "BEN GUERIR": ["EA"],
    "SAFI": ["H", "HH"],
    "YOUSSOUFIA": ["HA"],
    "EL KELAA DES SRAGHNA": ["Y"],
    "TANGER": ["K", "KB"],
    "ASSILAH": ["KA"],
    "TETOUAN": ["L"],
    "LARACHE": ["LA"],
    "KSAR EL KEBIR": ["LB"],
    "CHEFCHAOUEN": ["LC"],
    "MARTIL": ["LE"],
    "FNIDEQ": ["LF"],
    "MDIQ": ["LG"],
    "AL HOCEIMA": ["R"],
    "IMZOUREN": ["RB"],
    "TARGUIST": ["RC"],
    "BENI BOUAYACH": ["RX"],
    "OUJDA": ["F"],
    "BERKANE": ["FA"],
    "TAOURIRT": ["FB"],
    "EL AIOUN SIDI MELLOUK": ["FC"],
    "AIN BENI MATHAR": ["FD"],
    "SAIDIA": ["FE"],
    "FIGUIG": ["FG"],
    "JERADA": ["FH"],
    "AHFIR": ["FJ"],
    "TOUISSIT": ["FK"],
    "BOUARFA": ["FL"],
    "AGADIR": ["J", "JK"],
    "INZEGANE": ["JB"],
    "TAROUDANT": ["JC"],
    "TIZNIT": ["JE"],
    "CHTOUKA AIT BAHA": ["JH"],
    "AIT MELLOUL, TEMSIA, LQLIAA, OULAD DAHOU": ["JM"],
    "OULED TEIMA": ["JT"],
    "BENI MELLAL": ["I"],
    "KASBA TADLA": ["IA"],
    "FQIH BEN SALEH": ["IB"],
    "AZILAL": ["IC"],
    "SOUK SEBT": ["ID"],
    "DEMNATE": ["IE"],
    "KHENIFRA": ["V"],
    "MIDELT, ITZER": ["VA"],
    "M'RIRT": ["VM"],
    "EL JADIDA": ["M"],
    "AZEMMOUR": ["MA"],
    "SIDI BENNOUR": ["MC"],
    "ZEMAMRA": ["MD"],
    "ESSAOUIRA": ["N"],
    "DAKHLA": ["O", "OD"],
    "OUARZAZATE": ["P"],
    "TINGHIR": ["PA"],
    "ZAGORA": ["PB"],
    "KHOURIBGA": ["Q"],
    "OUED ZEM": ["QA"],
    "BEJAAD": ["QB"],
    "NADOR": ["S", "SA"],
    "ZEGANGAN": ["SB"],
    "LAAYOUNE": ["SH"],
    "SMARA": ["SJ"],
    "TARFAYA": ["SK"],
    "BOUJDOUR": ["SL"],
    "ERRACHIDIA": ["U"],
    "GOULMIMA": ["UA"],
    "RICH": ["UB"],
    "ERFOUD": ["UC"],
    "RISSANI": ["UD"],
    "KHEMISSET": ["X"],
    "TIFLET": ["XA"],
    "TAZA": ["Z"],
    "GUERCIF": ["ZG"],
    "KARIA BA MOHAMED": ["ZH"],
    "TAOUNATE": ["ZT"],
    "GUELMIM": ["JA"],
    "SIDI IFNI": ["JD"],
    "TAN-TAN": ["JF"],
    "TATA": ["JY"],
    "ASSA-ZAG": ["JZ"],
    "MAROCAINS RESIDENTS À L'ETRANGER": [
        "BX",
        "DF",
        "PK",
        "PP",
        "PS",
        "PH",
        "PY",
        "ES",
    ],
}
